#include <sourcemod>
#include <sdkhooks>
#include <vip_core>

#pragma newdecls required

#define VIP_FEATURE	"NoDamageVelocity"

public Plugin myinfo =
{
	name = "[VIP] No Damage Velocity Reduction",
	author = "HolyHender | Credits: inklesspen",
	version = "1.0.0"
}

float _stamina

public void VIP_OnVIPLoaded()
{
    VIP_RegisterFeature(VIP_FEATURE, BOOL);
}

public void OnPluginStart() 
{ 
	if(VIP_IsVIPLoaded()) VIP_OnVIPLoaded();
}

public void OnPluginEnd() 
{
	VIP_UnregisterFeature(VIP_FEATURE);
}

public void OnClientPutInServer(int client)
{
	SDKHook(client, SDKHook_OnTakeDamage, OnTakeDamage)
	SDKHook(client, SDKHook_OnTakeDamagePost, OnTakeDamagePost)
}

public Action OnTakeDamage(int victim, int& attacker, int& inflictor, float& damage, int& damagetype, int& weapon, float damageForce[3], float damagePosition[3], int damagecustom)
{
	_stamina = GetEntPropFloat(victim, Prop_Send, "m_flStamina")
}

public void OnTakeDamagePost(int victim, int attacker, int inflictor, float damage, int damagetype, int weapon, const float damageForce[3], const float damagePosition[3], int damagecustom)
{
	if(VIP_IsClientFeatureUse(victim, VIP_FEATURE))
	{	
		if(attacker != 0 && attacker != -1)
			SetEntPropFloat(victim, Prop_Send, "m_flStamina", _stamina)
		SetEntPropFloat(victim, Prop_Send, "m_flVelocityModifier", 1.0)
	}
}